
# <tt>issuebot</tt>

Our friendly robot that reads issues and merge requests, and responds
inline.  It is designed around GitLab CI as the service that runs it,
and integrates tightly with it.


# Modules

This is build around modules that can run separately, crash,
etc. without affecting the whole process.  Each module also returns
its results as a YAML dictionary to _stdout_ so that the core
_issuebot_ can format all the results into a nice report which is
posted in a single message.


## Variables

Things that need to be shared across multiple modules should be
exported as environment variables.  GitLab CI handles environment
variables quite well.  The _ApplicationID_ is also used to name the
APK and the local source folder, following F-Droid conventions.


* _ISSUEBOT_CURRENT_APPLICATION_ID_ - the _ApplicationID_ of the current app
* _ISSUEBOT_CURRENT_ISSUE_ID_ - the number of the GitLab Issue currently being processed
* _ISSUEBOT_CURRENT_SOURCE_URL_ - the URL to the source repo for the current app, if this is set, then a local copy of the source code will be available at _build/<ApplicationID>_


## API

There are lots of helper functions and methods for common operations
available to _issuebot_ modules that subclass `IssuebotModule`.


## Module Setup

_issuebot_ will install and remove things for the modules.  It will
currently handle _apt-get_ and _pip_.  Add a space separated list of
packages to these variable names in a comment:

* _issuebot_apt_install_ - list of packages to install using `apt-get install`
* _issuebot_apt_remove_ - list of packages to uninstall using `apt-get purge`
* _issuebot_pip_install_ - list of packages to install with `pip install`
* _issuebot_pip_remove_ - list of packages to install with `pip uninstall`


## Return Result

```yaml
# a block of HTML compatible with GitLab Markdown
report: |
  <details>
  <summary>This stuff was found</summary>
  <ul>
  <li>scary</li>
  <li>beautiful</li>
  <li>awful</li>
  <li>ugly</li>
  </ul>
  </details>
emoji:
  - tada
labels:
  - on-fdroid.org
```

## `fdroid-bot` label

[_issuebot_](https://gitlab.com/fdroid/issuebot) runs on a schedule to
scan all new submissions and post its reports directly to the issue or
merge request.  Once _issuebot_ completes posting its report, it will
add the `fdroid-bot` label to the issue or merge request.  That tells
_issuebot_ to ignore the issue in future runs.  If you want _issuebot_
to run on any item again, remove the `fdroid-bot` label.  On the next
run, _issuebot_ will consider that issue as if it had not seen it.




# JSON REST API

_issuebot_ also provides a JSON API on top of the current HTML
reports, so that any web app can use the data in their own user
experience. This can be combined with our other developing APIs, like
the [_buildserver_ status API](https://f-droid.org/repo/status/running.json).
There are two entry points:

* source code URL: [RFP](https://fdroid.gitlab.io/rfp/issuebot/sourceUrls.json) / [_fdroiddata_](https://fdroid.gitlab.io/fdroiddata/issuebot/sourceUrls.json)
* Application ID: [RFP](https://fdroid.gitlab.io/rfp/issuebot/applicationIds.json) / [_fdroiddata_](https://fdroid.gitlab.io/fdroiddata/issuebot/applicationIds.json)

Here is an excerpt of the Application ID entry point that shows the
_issuebot_ runs for one specific app.  There are two runs, with the
most recent first.  The newer version has the results from more
modules that were added since the first run.

```json
  "at.roteskreuz.stopcorona": [
    {
      "issueId": 1319,
      "jobId": "925261691",
      "modules": [
        "925261691/1319/active-hostnames.py.json",
        "925261691/1319/check-for-translation-service.py.json",
        "925261691/1319/dependencies-scrape.py.json",
        "925261691/1319/fastlane.py.json",
        "925261691/1319/fdroid-scan-apk.py.json",
        "925261691/1319/fdroid-scanner.py.json",
        "925261691/1319/gradle-productFlavors.py.json",
        "925261691/1319/gradle-wrapper.py.json",
        "925261691/1319/links-to-services.py.json",
        "925261691/1319/sdk.py.json",
        "925261691/1319/suspicious-names.py.json",
      ],
      "successfulBuilds": []
    },
    {
      "issueId": 1319,
      "jobId": "600681223",
      "modules": [
        "600681223/1319/check-for-translation-service.py.json",
        "600681223/1319/dependencies-scrape.py.json",
        "600681223/1319/fastlane.py.json",
        "600681223/1319/fdroid-scan-apk.py.json",
        "600681223/1319/fdroid-scanner.py.json",
        "600681223/1319/gradle-productFlavors.py.json",
        "600681223/1319/gradle-wrapper.py.json"
        "600681223/1319/sdk.py.json",
        "600681223/1319/suspicious-names.py.json",
      ]
    }
  ],
```

The ultimate entry is a catalog of what _issuebot_ saw in one
particular app in one particular run, identified by the GitLab CI
Job ID.  That includes a list of relative paths to the JSON output of
the _issuebot_ modules that ran.  The easiest way to get started with
the API right now is to download the whole collection of files from
the GitLab CI Job: go to the RFP
[Pipelines](https://gitlab.com/fdroid/rfp/-/pipelines) and click the
most recent download link on the right-most column.
